ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.17 by root, Sun Dec 12 00:38:36 2010 UTC vs.
Revision 1.40 by root, Sun May 1 07:56:26 2011 UTC

6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10# perl build variables 10# perl build variables
11MAKE=make
11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
12PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
13PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
14PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
15 17
16ARCH="$(uname -m)" 18ARCH="$(uname -m)"
17 19
18case "$ARCH" in 20case "$ARCH" in
27esac 29esac
28 30
29# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
30# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
31# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
32PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
33PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
34 37
35# some configuration options for modules 38# some configuration options for modules
36export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
37#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
38export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
39 44
40# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
41# required by mkbundle 46# required by mkbundle
42STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
43 48
44# which extra modules you might want to install 49# which extra modules you might want to install
45EXTRA_MODULES="" 50EXTRA_MODULES=""
46 51
47# overridable functions 52# overridable functions
48preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
49postconfigure() { : ; } 55postconfigure() { : ; }
50postbuild() { : ; } 56postbuild() { : ; }
51postinstall() { : ; } 57postinstall() { : ; }
52 58
53# now source user config, if any 59# now source user config, if any
60fi 66fi
61 67
62############################################################################# 68#############################################################################
63# support 69# support
64 70
65MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
66PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
67 72
68unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
69export LC_ALL=C # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
70 80
71# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
72VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
73$VERSION=0.911 83$VERSION="1.21"
74 84
75BZ2=bz2 85BZ2=bz2
76BZIP2=bzip2 86BZIP2=bzip2
77 87
78fatal() { 88fatal() {
124 134
125clean() { 135clean() {
126 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
127} 137}
128 138
139realclean() {
140 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
143}
144
129fetch() { 145fetch() {
130 rcd "$STATICPERL" 146 rcd "$STATICPERL"
131 147
132 mkdir -p src 148 mkdir -p src
133 rcd src 149 rcd src
143perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
144trying $URL 160trying $URL
145EOF 161EOF
146 162
147 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 163 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
164 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
148 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 165 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
149 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
150 || fatal "$URL: unable to download" 166 || fatal "$URL: unable to download"
167 rm -f perl-$PERL_VERSION.tar.$BZ2
151 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 168 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
152 fi 169 fi
153 170
154 verblock <<EOF 171 verblock <<EOF
155unpacking perl 172unpacking perl
156EOF 173EOF
157 174
158 mkdir -p unpack 175 mkdir -p unpack
176 rm -rf unpack/perl-$PERL_VERSION
159 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 177 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
160 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 178 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
161 chmod -R u+w unpack/perl-$PERL_VERSION 179 chmod -R u+w unpack/perl-$PERL_VERSION
162 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 180 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
163 rmdir -p unpack 181 rmdir -p unpack
164 fi 182 fi
165} 183}
166 184
167# similar to GNU-sed -i or perl -pi 185# similar to GNU-sed -i or perl -pi
168sedreplace() { 186sedreplace() {
169 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 187 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
188 rm -f "$2"
170 mv "$2~" "$2" 189 mv "$2~" "$2"
190}
191
192configure_failure() {
193 cat <<EOF
194
195
196***
197*** Configure failed - see above for the exact error message(s).
198***
199*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
200*** flags are not supported by your compiler. Less often, this is because
201*** PERL_LIBS either contains a library not available on your system (such as
202*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
203***
204*** You can provide your own flags by creating a ~/.staticperlrc file with
205*** variable assignments. For example (these are the actual values used):
206***
207
208PERL_CC="$PERL_CC"
209PERL_CCFLAGS="$PERL_CCFLAGS"
210PERL_OPTIMIZE="$PERL_OPTIMIZE"
211PERL_LDFLAGS="$PERL_LDFLAGS"
212PERL_LIBS="$PERL_LIBS"
213
214EOF
215 exit 1
171} 216}
172 217
173configure() { 218configure() {
174 fetch 219 fetch
175 220
181configuring $STATICPERL/src/perl-$PERL_VERSION 226configuring $STATICPERL/src/perl-$PERL_VERSION
182EOF 227EOF
183 228
184 rm -f "$PERL_PREFIX/staticstamp.install" 229 rm -f "$PERL_PREFIX/staticstamp.install"
185 230
186 make distclean >/dev/null 2>&1 231 "$MAKE" distclean >/dev/null 2>&1
187 232
233 sedreplace '/^#define SITELIB/d' config_h.SH
234
188 # I hate them 235 # I hate them for this
189 grep -q -- -fstack-protector Configure && \ 236 grep -q -- -fstack-protector Configure && \
190 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 237 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
191 238
192 preconfigure 239 # what did that bloke think
240 grep -q -- usedl=.define hints/darwin.sh && \
241 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
242
243 preconfigure || fatal "preconfigure hook failed"
193 244
194# trace configure \ 245# trace configure \
195 sh Configure -Duselargefiles \ 246 sh Configure -Duselargefiles \
196 -Uuse64bitint \ 247 -Uuse64bitint \
197 -Dusemymalloc=n \ 248 -Dusemymalloc=n \
198 -Uusedl \ 249 -Uusedl \
199 -Uusethreads \ 250 -Uusethreads \
200 -Uuseithreads \ 251 -Uuseithreads \
201 -Uusemultiplicity \ 252 -Uusemultiplicity \
202 -Duseperlio \
203 -Uusesfio \ 253 -Uusesfio \
204 -Uuseshrplib \ 254 -Uuseshrplib \
255 -Uinstallusrbinperl \
205 -Dcppflags="$PERL_CPPFLAGS" \ 256 -A ccflags=" $PERL_CCFLAGS" \
206 -Dccflags="-g2 -fno-strict-aliasing" \ 257 -Dcc="$PERL_CC" \
207 -Doptimize="$PERL_OPTIMIZE" \ 258 -Doptimize="$PERL_OPTIMIZE" \
208 -Dldflags="$PERL_LDFLAGS" \ 259 -Dldflags="$PERL_LDFLAGS" \
209 -Dlibs="$PERL_LIBS" \ 260 -Dlibs="$PERL_LIBS" \
210 -Dprefix="$PERL_PREFIX" \ 261 -Dprefix="$PERL_PREFIX" \
211 -Dbin="$PERL_PREFIX/bin" \ 262 -Dbin="$PERL_PREFIX/bin" \
212 -Dprivlib="$PERL_PREFIX/lib" \ 263 -Dprivlib="$PERL_PREFIX/lib" \
213 -Darchlib="$PERL_PREFIX/lib" \ 264 -Darchlib="$PERL_PREFIX/lib" \
214 -Uusevendorprefix \ 265 -Uusevendorprefix \
215 -Dsitelib="$PERL_PREFIX/lib" \ 266 -Dsitelib="$PERL_PREFIX/lib" \
216 -Dsitearch="$PERL_PREFIX/lib" \ 267 -Dsitearch="$PERL_PREFIX/lib" \
217 -Usitelibexp \
218 -Uman1dir \ 268 -Uman1dir \
219 -Uman3dir \ 269 -Uman3dir \
220 -Usiteman1dir \ 270 -Usiteman1dir \
221 -Usiteman3dir \ 271 -Usiteman3dir \
222 -Dpager=/usr/bin/less \ 272 -Dpager=/usr/bin/less \
223 -Demail="$EMAIL" \ 273 -Demail="$EMAIL" \
224 -Dcf_email="$EMAIL" \ 274 -Dcf_email="$EMAIL" \
225 -Dcf_by="$EMAIL" \ 275 -Dcf_by="$EMAIL" \
226 $PERL_CONFIGURE \ 276 $PERL_CONFIGURE \
277 -Duseperlio \
227 -dE || fatal "Configure failed" 278 -dE || configure_failure
228 279
229 sedreplace ' 280 sedreplace '
230 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 281 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
231 s/ *-fno-stack-protector */ /g 282 s/ *-fno-stack-protector */ /g
232 ' config.sh 283 ' config.sh
233 284
285 patchconfig || fatal "patchconfig hook failed"
286
234 sh Configure -S || fatal "Configure -S failed" 287 sh Configure -S || fatal "Configure -S failed"
235 288
236 postconfigure || fatal "postconfigure hook failed" 289 postconfigure || fatal "postconfigure hook failed"
237 290
238 touch staticstamp.configure 291 touch staticstamp.configure
292}
293
294write_shellscript() {
295 {
296 echo "#!/bin/sh"
297 echo "STATICPERL=\"$STATICPERL\""
298 echo "PERL_PREFIX=\"$PERL_PREFIX\""
299 echo "MAKE=\"$MAKE\""
300 cat
301 } >"$PERL_PREFIX/bin/$1"
302 chmod 755 "$PERL_PREFIX/bin/$1"
239} 303}
240 304
241build() { 305build() {
242 configure 306 configure
243 307
247building $STATICPERL/src/perl-$PERL_VERSION 311building $STATICPERL/src/perl-$PERL_VERSION
248EOF 312EOF
249 313
250 rm -f "$PERL_PREFIX/staticstamp.install" 314 rm -f "$PERL_PREFIX/staticstamp.install"
251 315
252 make || fatal "make: error while building perl" 316 "$MAKE" || fatal "make: error while building perl"
253 317
254 postbuild || fatal "postbuild hook failed" 318 postbuild || fatal "postbuild hook failed"
255} 319}
256 320
257install() { 321install() {
264EOF 328EOF
265 329
266 ln -sf "perl/bin/" "$STATICPERL/bin" 330 ln -sf "perl/bin/" "$STATICPERL/bin"
267 ln -sf "perl/lib/" "$STATICPERL/lib" 331 ln -sf "perl/lib/" "$STATICPERL/lib"
268 332
333 mkdir "$STATICPERL/patched"
334
269 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 335 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
270 rm -rf "$PERL_PREFIX" # by this rm -rf 336 rm -rf "$PERL_PREFIX" # by this rm -rf
271 337
272 make install || fatal "make install: error while installing" 338 "$MAKE" install || fatal "make install: error while installing"
273 339
274 rcd "$PERL_PREFIX" 340 rcd "$PERL_PREFIX"
275 341
276 # create a "make install" replacement for CPAN 342 # create a "make install" replacement for CPAN
277 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 343 write_shellscript SP-make-install-make <<'EOF'
278make || exit 344#CAT make-install-make.sh
279
280if find blib/arch/auto -type f | grep -q -v .exists; then
281 echo Probably an XS module, rebuilding perl
282 if make perl; then
283 mv perl "$PERL_PREFIX"/bin/perl
284 make -f Makefile.aperl map_clean
285 else
286 make -f Makefile.aperl map_clean
287 exit 1
288 fi
289fi
290
291make install UNINST=1
292EOF 345EOF
293 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
294 346
347 # create a "patch modules" helper
348 write_shellscript SP-patch-postinstall <<'EOF'
349#CAT patch-postinstall.sh
350EOF
351
352 "$PERL_PREFIX/bin/SP-patch-postinstall"
353
295 # trick CPAN into avoiding ~/.cpan completely 354 # help to trick CPAN into avoiding ~/.cpan completely
296 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 355 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
297 356
357 # we call cpan with -MCPAN::MyConfig in this script, which
358 # is strictly unnecssary as we have to patch CPAN anyway,
359 # so consider it "for good measure".
298 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 360 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
299 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 361 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
300 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 362 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
301 CPAN::Shell->o (conf => q<init>); 363 CPAN::Shell->o (conf => q<init>);
302 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 364 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
303 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 365 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
304 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 366 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
305 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 367 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
306 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 368 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
307 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 369 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
308 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 370 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
309 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 371 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
372 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
310 CPAN::Shell->o (conf => q<commit>); 373 CPAN::Shell->o (conf => q<commit>);
311 ' || fatal "error while initialising CPAN" 374 ' || fatal "error while initialising CPAN"
312 375
313 touch "$PERL_PREFIX/staticstamp.install" 376 touch "$PERL_PREFIX/staticstamp.install"
314 fi 377 fi
334installing modules from CPAN 397installing modules from CPAN
335$@ 398$@
336EOF 399EOF
337 400
338 for mod in "$@"; do 401 for mod in "$@"; do
339 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 402 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
340 || fatal "$mod: unable to install from CPAN" 403 || fatal "$mod: unable to install from CPAN"
341 done 404 done
342 rm -rf "$STATICPERL/build" 405 rm -rf "$STATICPERL/build"
343} 406}
344 407
356 for mod in "$@"; do 419 for mod in "$@"; do
357 echo 420 echo
358 echo $mod 421 echo $mod
359 ( 422 (
360 rcd $mod 423 rcd $mod
361 make -f Makefile.aperl map_clean >/dev/null 2>&1 424 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
362 make distclean >/dev/null 2>&1 425 "$MAKE" distclean >/dev/null 2>&1
363 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 426 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
364 make || fatal "$mod: error building module" 427 "$MAKE" || fatal "$mod: error building module"
365 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 428 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
366 make distclean >/dev/null 2>&1 429 "$MAKE" distclean >/dev/null 2>&1
367 exit 0 430 exit 0
368 ) || exit $? 431 ) || exit $?
369 done 432 done
370} 433}
371 434
402#CAT mkbundle 465#CAT mkbundle
403MKBUNDLE 466MKBUNDLE
404} 467}
405 468
406bundle() { 469bundle() {
470 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
407 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 471 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
408 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 472 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
409 CACHE="$STATICPERL/cache" 473 CACHE="$STATICPERL/cache"
410 mkdir -p "$CACHE" 474 mkdir -p "$CACHE"
411 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 475 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
419 command="${1#--}"; shift 483 command="${1#--}"; shift
420 case "$command" in 484 case "$command" in
421 version ) 485 version )
422 echo "staticperl version $VERSION" 486 echo "staticperl version $VERSION"
423 ;; 487 ;;
424 fetch | configure | build | install | clean | distclean) 488 fetch | configure | build | install | clean | realclean | distclean)
425 ( "$command" ) 489 ( "$command" ) || exit
426 ;; 490 ;;
427 instsrc ) 491 instsrc )
428 ( instsrc "$@" ) 492 ( instsrc "$@" ) || exit
429 exit 493 exit
430 ;; 494 ;;
431 instcpan ) 495 instcpan )
432 ( instcpan "$@" ) 496 ( instcpan "$@" ) || exit
497 exit
498 ;;
499 perl )
500 ( install ) || exit
501 exec "$PERL_PREFIX/bin/perl" "$@"
433 exit 502 exit
434 ;; 503 ;;
435 cpan ) 504 cpan )
436 ( install ) 505 ( install ) || exit
437 "$PERL_PREFIX/bin/cpan" "$@" 506 exec "$PERL_PREFIX/bin/cpan" "$@"
438 exit 507 exit
439 ;; 508 ;;
440 mkbundle ) 509 mkbundle )
441 ( install ) 510 ( install ) || exit
442 bundle "$@" 511 bundle "$@"
443 exit 512 exit
444 ;; 513 ;;
445 mkperl ) 514 mkperl )
446 ( install ) 515 ( install ) || exit
447 bundle --perl "$@" 516 bundle --perl "$@"
448 exit 517 exit
449 ;; 518 ;;
450 mkapp ) 519 mkapp )
451 ( install ) 520 ( install ) || exit
452 bundle --app "$@" 521 bundle --app "$@"
453 exit 522 exit
454 ;; 523 ;;
455 help ) 524 help )
456 podusage 2 525 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines